
/*
   Site Update - Update web pages
   by Denis G. Sureau - www.scriptol.com
   Licence: Mozilla 1.1

   Use freely this script
   but always provide the scriptol source and the licence when you distribute the program.

   Rules:
   The program get a part of code enclosed between two tags, and copy it into each page 
   holding the same two tags (replacing the enclosed part).
   The starting tag may be <!--XSTARTx--> or <!--XSTART0--> or <!--XSTART1-->,
   etc... until <!--XSTARTz-->
   Any letter may be used as indice, preferably use common ascii 0-9,
   A-Z, a-z...  The default is the X character, thus <!--XSTARTX-->.

   The default may by changed in updater.ini.

   To use this tool, enclose a part of code in the model page between the starting and ending tags, 
   and put theses tag, enclosing nothing, in any page where you want to insert the same, enclosed code.
   
   You can use supdate also to add text (the full content of a text file, written for this purpose)
   into a set of text files, at top.
   
*/


``    This program is free software; you can redistribute it and/or modify
``    it under the terms of the OSS License.
``    This program is distributed in the hope that it will be useful,
``    but WITHOUT ANY WARRANTY; without even the implied warranty of
``    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  



include "path.sol"
include "dirlist.sol"

array extensions = {"htm", "html", "php", "php3", "php4", "php5", "xhtml", "dhtml", "asp"}
text tagstart ="<!--XSTARTX-->"
text tagend   ="<!--XENDX-->"
array replacing		`` code to copy
text sourcefile 
boolean INSERTING = false
boolean RECURSE = false
boolean DISPMARKS = true
int counter


void usage()
  print
  print "Site Update 3.0 - www.scriptol.com"
  print "---------------------------------- "
  print "Insert or update a text into a set of files."
  print "Usage:"
  print "   supdate [options] sourcefile"
  print "Options:"
  print "   #n      digit or letter to select the marker (default is X)" 
  print "   -a      addthe whole source file at top of each page (no marker required)"
  print "   -r      recursively update content of subdirectories."
  print
  print "The code to insert/replace is recognized by markers in source file,"
  print "and the location in target files is recognized by same markers."
  print "A digit or letter may be given as parameter to select a marker."
  print "Example:  #1 for the marker <!--XSTART1--> while default is <!--XSTARTX-->"
  print "The default marker could be changed in supdate.ini."
  exit(0)
return


void readIni(text inipath)

	array ini
	inipath = Path.changeExt(inipath, "ini")
	if not file_exists(inipath) return
	ini.load(inipath)
	if(ini.size() = 0)
		print inipath, "file not loaded"
		return
	/if

	for text option in ini
		option = option.trim()        ` remove trailing spaces and eol
		if option.length() < 1 continue
		if option[0] = "#" continue
		int i = option.find("=")      ` parse a line
		if i = nil  continue          ` no valid couple key=value
		text k = option[--i].trim()   ` key
		text v = option[i+1..].trim() ` value
		if k
		= "start": tagstart = v
		= "end":   tagend = v
		= "extensions" : extensions = v.split(",")
		= "extension" : extensions = v.split(",")
		/if
	/for

return


int, int findInArray(array a, text starting, text closing)
    int size = a.size()
    int start = -1
    for int i in 0 -- size
       text line = a[i]
       if starting in line 
          start = i
          break
       /if    
	  /for   
    if start = -1 
      if DISPMARKS print "First marker '$starting' not found..."
      return -1, -1
    /if  

    for int i in start -- size
       text line = a[i]
       if closing in line return start, i 
	  /for
    if DISPMARKS print "Closing marker '$closing' not found..."   
return -1, -1

`` Get the code to insert

void extracting()
	array source
	
	if not file_exists(sourcefile)
		print sourcefile, "not found"
		exit()
	/if
	
	source.load(sourcefile)
	if source.size() = 0
		print sourcefile, "source empty"
		exit(0)
	/if

  int numstt, numend
	numstt, numend = findInArray(source, tagstart, tagend)
	if (numstt = -1) or (numend = -1)
		print "Markers not found in", sourcefile
		print "These tags are required both in source and targets:"
		print tagstart, "(Start of code to copy)"
		print tagend, "(End of code to copy)"
		exit(0)
	/if
	replacing = source[numstt .. numend]	`` Insert the code in each file in the list, inside markers 
	
return


`` Insert the code at top of each page

void inserting()

	array target

    array targetlist

	for text t in targetlist
		t = t.trim()
		if t.length() = 0 continue
		if not file_exists(t)
			print t, "no found"
			continue
		/if
		target.load(t)
		if target.size() = 0
			print t, "target empty"
			continue
		/if

		file x
		x.open(t, "w")
		scan replacing let x.write(replacing[])
		scan target let x.write(target[])
		print t, "modified"
		counter + 1
		x.close()
	/for

return 


`` Update  the code inside markers

void updating()

	array target
	text t
	text thedir
	text dirname
	
	thedir = getcwd()
    if Path.type(thedir) <> "dir" ? return 
    
    print
    text here = getcwd()
    print here
    print '-'.dup(here.length()) 

    dir handle = opendir(thedir)	
    rewinddir(handle)	

	int tarstt, tarend
    do
        t = readdir(handle)
        if t = nil ? break
        if t in (".", "..") ? continue
        
		if not Path.isFile(t) continue
		
        text node, ext
		node, ext = Path.splitExt(t)
		if ext not in extensions continue
		if Path.compare(sourcefile, t) continue      // don't update the model!
		
		target.load(t)
		if target.size() = 0
			print t, "Target empty"
			continue
		/if
		
		tarstt, tarend = findInArray(target,tagstart, tagend)
		if (tarstt = -1) or (tarend = -1)
			print "Nothing to replace in", t + ", skipped"
			continue
		/if
		target[tarstt .. tarend] = replacing
		
		file f = fopen(t, "wb")
		for text line in target
			f.write(line)
		/for
		f.close()
		
		print t, "updated"
		counter + 1
		
    /do forever
	
    if RECURSE = false
       closedir(handle)
       return 
    /if

   rewinddir(handle)

   do
        dirname = readdir(handle)
        if dirname = nil ? break
        if dirname in (".", "..") ? continue
 	
		if Path.isDir(dirname)
		     chdir(dirname)
             updating()
		     chdir("..")
		/if
   /do forever
   
   closedir(handle)
	
return

`` Main script

int main(int argc, array argv)

	if argc not in 2 ..  4 let usage()
	text listname = ""
	text tagindex = 'X'
	
	boolean modelgot = false
	boolean dirgot = false
	
	for text option in argv[ 1 .. ]
		text firstchar = option[0]
		if firstchar
		= "-":   
			if option 
			= "-i":	
				INSERTING = true
			= "-r":
                RECURSE = true	
			else
				usage()
			/if	
		= "#":
			tagindex = option[1]		
		else
			if modelgot = true
				usage()
			else
				sourcefile = option
				modelgot = true
			/if	
		/if	
	/for		
	
	readIni("siteupd.ini")

	tagstart[10] = tagindex		`` remain # or get a number
	
	print "Extensions:", extensions.join(" ")

	if not file_exists(sourcefile)
		print sourcefile, "source file not found..."
		exit()
	/if
	
	counter = 0

	if INSERTING = true
		replacing.load(sourcefile)
		inserting()
	else	
		extracting()						`` Get the code in the model, from markers	
    DISPMARKS = false
		updating()
	/if
	
	print counter, "files updated..."

return 0


main($argc, $argv)
